'imgsize.bas - Copyright 1996 John E. Carter - All Rights Reserved
' 1.0 - original version created from gifsize and jpegsize
' 1.1 - 01/28/96 - jec - added filesize to image tag line
' 1.2 - 05/15/96 - jec - put filesize inside ALT= field
' 1.3 - 06/06/96 - jec - changed jpeg processing to match gif processing
' 1.4 - 04/11/2001 - jec - added EXIF handling
defint a-z
doall = 0
isgif = 0
isjpg = 0
isexif = 0
unknown = 0
jfif$ = "JFIF"+chr$(0)
exif$ = "EXIF" + chr$(0)
inf$=ucase$(command$)
if inf$="" then
  print
  print "imgsize version 1.4 - April 11, 2001"
  print
  print "imgsize reads the WIDTH and HEIGHT of GIF and JPEG graphics and creates a"
  print "an HTML image definition line (complete with file size) for each file read."
  print "Like this: <IMG WIDTH=xx HEIGHT=yy SRC=";chr$(34);"filename.xxx";chr$(34);" ALT=";chr$(34);"filename [xxK]";chr$(34);">"
  print "imgsize looks for a filename ending in .gif or .jpg if no extension is given."
  print "It will use any file name if you specify the full filename.ext."
  print "imgsize should be run from the directory which contains the images of interest."
  print "The output of imgsize may be redirected to a file."
  print "If your images are in a subdirectory under the HTML files, you can add"
  print "the subdirectory name to the SRC path with the /d option.  See examples."
  print "If you don't write HTML, you have no idea how useful this program is."
  print
  print "imgsize is Copyright 1996-2001 by John E. Carter.  It may be freely distributed"
  print "but MAY NOT BE SOLD.  Questions or comments to johnecarter@mindspring.com"
  print
  print "usage: imgsize filename"
  print "       imgsize /all"
  print "       imgsize filename /dImage_directory"
  print "       imgsize /all /dImage_directory"
  print "       imgsize /all > image.lst"
  print "Arguments must be in the order shown: imgsize filename /all /dxxxx."
  end
end if
prefix$ = ""
p1 = instr(inf$, "/D")
p2 = instr(inf$, "-D")
if p1 then
  prefix$ = mid$(command$, p1 + 2) + "/"
end if
if p2 then
  prefix$ = mid$(command$, p2 + 2) + "/"
end if
?"prefix=";prefix$
dotloc=instr(inf$,".")
if dotloc = 0 then
  if instr(inf$,"/ALL") > 0 or instr(inf$,"-ALL") > 0 then
    doall = 1
  else
    gif$ = ltrim$(rtrim$(inf$)) + ".gif"
    dotloc = instr(gif$,".")
    jpeg$ = ltrim$(rtrim$(inf$)) + ".jpg"
  end if
else
  if right$(inf$,3) = "GIF" then
    isgif = 1
    gif$ = inf$
  end if
  if right$(inf$,3) = "JPG" then
    isjpg = 1
    jpeg$ = inf$
  end if
  if isgif = 0 and isjpg = 0 then
    unknown = 1
  end if
end if
open "CONS:" for output as 2
if doall = 0 then
  if unknown = 0 then
    if len(gif$) then
      k$ = dir$(gif$)
      if len(k$) then
	isgif = 1
      end if
    end if
    if isgif = 0 and len(jpeg$) then
      k$ = dir$(jpeg$)
      if len(k$) then
	isjpg = 1
      end if
    end if
    if k$ = "" then
      print "Can't find ";inf$
      end
    end if

    if isgif = 1 then
      open gif$ for binary as 1
      flen = lof(1)\1024
      get$ 1, 6, x$
      if left$(x$,3)<>"GIF" then
	print gif$;": not a GIF file"
	end
      end if
      inf$ = lcase$(gif$)
      call gifinfo
      close 1
    end if
    if isjpg = 1 then
      open jpeg$ for binary as 1
      flen = lof(1)\1024
      get$ 1, 100, x$
      if instr(x$,jfif$) = 0 then
	ux$ = ucase$(x$)
	if instr(ux$, exif$) = 0 then
	  print jpeg$;": not a JFIF (portable JPEG) file"
	  end
	else
	  isexif = 1
	end if
      end if
      inf$ = lcase$(jpeg$)
      if isexif then
	call exifinfo
      else
	call jpeginfo
      end if
      close 1
    end if
  else
    k$ = dir$(inf$)
    if k$ = "" then
      print "can't find ";inf$
      end
    end if
    open inf$ for binary as 1
    flen = lof(1)\1024
    get$ 1, 100, x$
    if instr(x$, "GIF") > 0 then
      isgif = 1
      inf$ = lcase$(inf$)
      call gifinfo
      close 1
    end if
    if instr(x$, jfif$) > 0 then
      isjpg = 1
      inf$ = lcase$(inf$)
      call jpeginfo
      close 1
    else
      if instr(x$, exif$) > 0 then
	isexif = 1
	inf$ = lcase$(inf$)
	call exifinfo
	close 1
      end if
    end if
    if isgif = 0 and isjpg = 0 and isexif = 0 then
      print inf$;": not a GIF or JPEG file"
      end
    end if
  end if
else
  inf$ = dir$("*.jpg")
  while inf$ <> ""
    isexif = 0
    dotloc = instr(inf$,".")
    open inf$ for binary as 1
    flen = lof(1)\1024
    get$ 1, 100, x$
    if instr(x$,jfif$) = 0 then
      ux$ = ucase$(x$)
      if instr(ux$, exif$) = 0 then
	print #2, inf$;" is not a JFIF (portable JPEG) file"
      else
	isexif = 1
      end if
    end if
    inf$ = lcase$(inf$)
    if isexif = 0 then
      call jpeginfo
    else
      call exifinfo
    end if
    close 1
    inf$ = dir$
  wend
  inf$ = dir$("*.gif")
  while inf$ <> ""
    dotloc = instr(inf$,".")
    open inf$ for binary as 1
    flen = lof(1)\1024
    get$ 1, 6, x$
    if left$(x$,3)<>"GIF" then
      print #2, inf$;" is not a GIF file"
    end if
    inf$ = lcase$(inf$)
    call gifinfo
    close 1
    inf$ = dir$
  wend
end if
close
end

SUB gifinfo
  SHARED inf$, dotloc, flen, prefix$
  get$ 1, 2, x$
  scrwidth=asc(left$(x$,1)) + 256 * asc(right$(x$,1))
  get$ 1, 2, x$
  scrheight=asc(left$(x$,1)) + 256 * asc(right$(x$,1))
  print #2, "<IMG WIDTH=";
  print #2, ltrim$(str$(scrwidth));
  print #2, " HEIGHT=";
  print #2, ltrim$(str$(scrheight));" SRC=";
  print #2, chr$(34);prefix$;ltrim$(rtrim$(inf$));chr$(34);
  filen$ = str$(flen)
  print #2, " ALT=";chr$(34);left$(inf$,dotloc -1);" [";ltrim$(rtrim$(filen$));"K]";chr$(34);">"
'  filen$ = str$(flen)
'  print #2, ""
END SUB

SUB jpeginfo
  SHARED inf$, dotloc, flen, prefix$
  sizemark$ = chr$(255) + chr$(192)
  seek #1, 0
  get$ 1, 3000, x$
  marker=instr(x$, sizemark$)
  if marker=0 then
    print inf$;": unrecognized file format"
    exit sub
  end if
  seek #1, 0
  seek #1, marker +4
  get$ 1, 2, x$
  scrheight=asc(right$(x$,1)) + 256 * asc(left$(x$,1))
  get$ 1, 2, x$
  scrwidth=asc(right$(x$,1)) + 256 * asc(left$(x$,1))
  print #2, "<IMG WIDTH=";
  print #2, ltrim$(str$(scrwidth));
  print #2, " HEIGHT=";
  print #2, ltrim$(str$(scrheight));" SRC=";
  print #2, chr$(34);prefix$;ltrim$(rtrim$(inf$));chr$(34);
  filen$ = str$(flen)
  print #2, " ALT=";chr$(34);left$(inf$,dotloc -1);" [";ltrim$(rtrim$(filen$));"K]";chr$(34);">"
'  print #2, " ALT=";chr$(34);left$(inf$,dotloc -1);chr$(34);">";
'  filen$ = str$(flen)
'  print #2, " [";ltrim$(rtrim$(filen$));"K]"
END SUB

SUB exifinfo
  SHARED inf$, dotloc, flen, prefix$
  sizemark$ = chr$(255) + chr$(192)
  seek #1, 0
  get$ 1, 3000, x$
  marker=instr(x$, sizemark$)
  if marker=0 then
    print inf$;": unrecognized file format"
    exit sub
  end if
  seek #1, 0
  get$ 1, 8000, x$
  marker = instr(marker + 4, x$, sizemark$)

  seek #1, 0
  seek #1, marker +4
  get$ 1, 2, x$
  scrheight=asc(right$(x$,1)) + 256 * asc(left$(x$,1))
  get$ 1, 2, x$
  scrwidth=asc(right$(x$,1)) + 256 * asc(left$(x$,1))
  print #2, "<IMG WIDTH=";
  print #2, ltrim$(str$(scrwidth));
  print #2, " HEIGHT=";
  print #2, ltrim$(str$(scrheight));" SRC=";
  print #2, chr$(34);prefix$;ltrim$(rtrim$(inf$));chr$(34);
  filen$ = str$(flen)
  print #2, " ALT=";chr$(34);left$(inf$,dotloc -1);" [";ltrim$(rtrim$(filen$));"K]";chr$(34);">"
'  print #2, " ALT=";chr$(34);left$(inf$,dotloc -1);chr$(34);">";
'  filen$ = str$(flen)
'  print #2, " [";ltrim$(rtrim$(filen$));"K]"
END SUB
